﻿Imports System.Xml

Public Structure GeomRule
    'Параметры для чтения геометрии
    'Public PolygonPath As String
    Public LineStringPath As String 'Путь для линий
    Public PointPath As String 'Путь для точек
    Public XPath As String 'Путь для X
    Public YPath As String 'Путь для Y
End Structure

Public Class MyStr1
    'Правила
    Public LayerName As String 'Имя слоя
    Public Title As New Microsoft.VisualBasic.Collection 'Сисок полей FieldList
    Public ShemaList As New Microsoft.VisualBasic.Collection 'Список схем ShemaList
    Public crShema As ShemaRec 'Текущая схема
    '
    Sub New(ByRef MyDoc As XmlDocument)
        'Считываем правила из файла
        Dim crNode, FieldList As XmlNode
        Dim nsmgr As XmlNamespaceManager
        '
        nsmgr = New XmlNamespaceManager(MyDoc.NameTable)
        nsmgr.AddNamespace("", MyDoc.NamespaceURI)
        FieldList = MyDoc.SelectSingleNode("//FieldList", nsmgr)
        LayerName = FieldList.Attributes.GetNamedItem("LayerName").Value
        For Each crNode In FieldList.ChildNodes 'Сисок полей FieldList
            Dim tRec As New TitleRec(Me, crNode)
            Title.Add(tRec)
        Next
        FieldList = MyDoc.SelectSingleNode("//ShemaList", nsmgr) 'Список схем ShemaList
        For Each crNode In FieldList.ChildNodes
            Dim tShemaRec As New ShemaRec(Me, crNode)
            ShemaList.Add(tShemaRec)
        Next
    End Sub

    Public Function LoadData(ByRef MyDoc As XmlDocument) As Microsoft.VisualBasic.Collection
        'Загружаем данные из файла
        Dim DocName As String
        DocName = MyDoc.DocumentElement.Name 'Получаем имя корневого элемета
        Dim sr As ShemaRec = Me.FindShema(DocName) 'Ищем нужную схему
        crShema = sr 'делаем её текущей
        Return sr.LoadLayer(MyDoc)  'читаем слой
    End Function

    Public Function SearchField(ByVal nid As Integer) As TitleRec
        'Поиск поля по id, в списке полей
        Dim res As Boolean = False
        Dim I As Integer = 1
        Dim tr As TitleRec = Nothing
        'Return Nothing
        Do
            tr = CType(Title.Item(I), TitleRec)
            If tr.id = nid Then
                res = True
                Return tr
            Else
                I = I + 1
            End If
        Loop Until (res Or I > Title.Count)
        If Not res Then Return Nothing
    End Function

    Public Function FindShema(ByVal DocName As String) As ShemaRec
        'Поиск схемы по имени корневого элемента
        Dim res As Boolean = False
        Dim I As Integer = 1
        Dim sr As ShemaRec = Nothing
        'Return Nothing
        Do
            sr = CType(ShemaList.Item(I), ShemaRec)
            If sr.rootElem = DocName Then
                res = True
                Return sr
            Else
                I = I + 1
            End If
        Loop Until (res Or I > Title.Count)
        If Not res Then Return Nothing
    End Function
    '
End Class

Public Class TitleRec
    'Описание поля
    Public MS As MyStr1
    Public id As Integer
    Public name As String
    Public type As String

    Sub New(ByRef Root As MyStr1, ByRef crNode As XmlNode)
        MS = Root
        id = crNode.Attributes.GetNamedItem("id").Value
        name = crNode.Attributes.GetNamedItem("Name").Value
        type = crNode.Attributes.GetNamedItem("type").Value
    End Sub

    Public ReadOnly Property IsGeom As Boolean
        Get
            If (type = "Point" Or type = "LineString" Or type = "Polygon") Then Return True Else Return False
        End Get
    End Property

End Class

Public Class FieldRule
    'Правило чтения поля 
    Public MS As MyStr1 'Родительски объект
    Public F As TitleRec 'Описание поля
    Public GR As GeomRule 'Параметры чтения геометрии
    Public Recid As Integer 'id поля
    Public IsGeom As Boolean = False 'признак геометрии
    Public path As String 'путь
    Public attr As String 'атрибут
    Public dict As String 'имя словаря

    Sub New(ByRef Root As MyStr1, ByRef nNode As XmlElement)
        'Чтение правила
        MS = Root
        Recid = CInt(nNode.Attributes.GetNamedItem("id").Value)
        F = MS.SearchField(Recid)
        If nNode.HasAttribute("geom") Then IsGeom = (nNode.Attributes.GetNamedItem("geom").Value = "true")
        If nNode.HasAttribute("path") Then path = nNode.Attributes.GetNamedItem("path").Value Else path = ""
        If nNode.HasAttribute("attr") Then attr = nNode.Attributes.GetNamedItem("attr").Value Else attr = ""
        If nNode.HasAttribute("dict") Then dict = nNode.Attributes.GetNamedItem("dict").Value Else dict = ""
        'Чтение правли для геометрии
        If IsGeom Then
            Dim GeomNode As XmlElement
            Select Case F.type
                Case "Point"
                    GeomNode = nNode.SelectSingleNode("//Point")
                Case "LineString"
                    GeomNode = nNode.SelectSingleNode("//Point")
                    GR.PointPath = GeomNode.Attributes.GetNamedItem("path").Value
                Case "Polygon"
                    GeomNode = nNode.SelectSingleNode("//LineString")
                    GR.LineStringPath = GeomNode.Attributes.GetNamedItem("path").Value
                    GeomNode = GeomNode.ChildNodes.Item(0)
                    GR.PointPath = GeomNode.Attributes.GetNamedItem("path").Value
            End Select
            GR.XPath = GeomNode.Attributes.GetNamedItem("Xattr").Value
            GR.YPath = GeomNode.Attributes.GetNamedItem("Yattr").Value
        End If
    End Sub
End Class

Public Class ShemaRec
    'Список правли для схемы
    Public MS As MyStr1 'Родительски объект
    Public rootElem As String  'Имя корневого элемета
    Public LayerPath As String 'Путь к слою
    Public Entpath As String 'Путь к элменту
    Public FieldRuleList As New Microsoft.VisualBasic.Collection() 'Список правил

    Sub New(ByRef Root As MyStr1, ByRef nNode As XmlNode)
        'Чтение списка правил для схемы
        MS = Root
        rootElem = nNode.Attributes.GetNamedItem("rootElem").Value
        LayerPath = nNode.Attributes.GetNamedItem("LayerPath").Value
        Entpath = nNode.Attributes.GetNamedItem("Entpath").Value
        Dim crNode As XmlNode
        For Each crNode In nNode.ChildNodes 'Чтение правил
            Dim tRec As New FieldRule(Root, crNode)
            FieldRuleList.Add(tRec)
        Next
    End Sub

    Public Function LoadLayer(ByRef XMLDoc As XmlDocument) As Microsoft.VisualBasic.Collection
        'Чтение данных слоя
        Dim I, J As Integer
        Dim LayersXmlNode, LayerXmlNode As XmlNode
        Dim LayersXmlNodeList, LayerXmlNodeList As XmlNodeList
        Dim nRecord As MyRecord
        Dim WorkList As New Microsoft.VisualBasic.Collection
        '
        LayersXmlNodeList = XMLDoc.SelectNodes(LayerPath) 'Получение слоя
        For I = 0 To LayersXmlNodeList.Count - 1
            LayersXmlNode = LayersXmlNodeList.Item(I)
            LayerXmlNodeList = LayersXmlNode.SelectNodes(Entpath) 'Получение элементов слоя
            For J = 0 To LayerXmlNodeList.Count - 1
                LayerXmlNode = LayerXmlNodeList.Item(J)
                nRecord = New MyRecord(MS, LayerXmlNode)
                WorkList.Add(nRecord) 'fff
            Next J
        Next I
        Return WorkList
    End Function

End Class