﻿Imports System.Xml

Public Class MyRecord
    Public MS As MyStr1
    Public FieldList As New Microsoft.VisualBasic.Collection
    Public Geom As MyField

    Sub New(ByRef Root As MyStr1, ByRef nNode As XmlElement)
        Dim I As Integer
        MS = Root
        FillFieldList(MS.Title)
        Dim FR As FieldRule
        Dim mf As MyField
        Dim crNode As XmlElement
        Dim resNode As XmlNode = Nothing
        For I = 1 To MS.crShema.FieldRuleList.Count
            FR = CType(MS.crShema.FieldRuleList.Item(I), FieldRule)
            '
            If FR.path <> "" Then
                crNode = nNode.SelectSingleNode(FR.path)
            Else
                crNode = nNode
            End If
            If FR.attr <> "" Then
                If crNode.HasAttribute(FR.attr) Then resNode = crNode.Attributes.GetNamedItem(FR.attr)
            Else
                resNode = crNode
            End If
            mf = SearchField(FR.Recid)
            If (Not IsNothing(mf)) And (Not IsNothing(resNode)) Then
                If Not FR.IsGeom Then
                    If FR.dict = "" Then mf.fValue = resNode.Value Else mf.fValue = LoadDictValue(FR, resNode.Value)
                Else
                    mf.fValue = LoadGeometry(mf.RecType, FR.GR, resNode)
                    Geom = mf
                End If
            End If
        Next I
    End Sub

    Public Sub FillFieldList(ByRef Title As Microsoft.VisualBasic.Collection)
        Dim I As Integer
        Dim tr As TitleRec = Nothing
        Dim mf As MyField
        '
        For I = 1 To Title.Count
            tr = CType(Title.Item(I), TitleRec)
            mf = New MyField(tr.id, tr.name, tr.type, Nothing)
            FieldList.Add(mf)
        Next I
    End Sub

    Public Function SearchField(ByVal nid As Integer) As MyField
        Dim res As Boolean = False
        Dim I As Integer = 1
        Dim tr As MyField = Nothing
        'Return Nothing
        Do
            tr = CType(FieldList.Item(I), MyField)
            If tr.Recid = nid Then
                res = True
                Return tr
            Else
                I = I + 1
            End If
        Loop Until (res Or I > FieldList.Count)
        If Not res Then Return Nothing
    End Function

    Public Function LoadPoint(ByVal GR As GeomRule, ByRef nNode As XmlElement) As TPoint
        Dim X, Y As Double
        Dim WorkStr As String
        WorkStr = nNode.Attributes.GetNamedItem(GR.XPath).Value
        X = Convert.ToDouble(WorkStr)
        WorkStr = nNode.Attributes.GetNamedItem(GR.YPath).Value
        Y = Convert.ToDouble(WorkStr)
        Return New TPoint(X, Y)
    End Function

    Public Function LoadLineString(ByVal GR As GeomRule, ByRef nNode As XmlElement) As TLineString
        Dim I As Integer
        Dim crNode As XmlElement
        Dim crNodes As XmlNodeList
        Dim workPoint As TPoint
        Dim PointList As New Microsoft.VisualBasic.Collection
        crNodes = nNode.SelectNodes(GR.PointPath)
        For I = 0 To crNodes.Count - 1
            crNode = crNodes.Item(I)
            workPoint = LoadPoint(GR, crNode)
            PointList.Add(workPoint)
        Next I
        Return New TLineString(PointList)
    End Function

    Public Function LoadGeometry(ByVal crType As String, ByVal GR As GeomRule, ByRef nNode As XmlElement) As TGeometry
        Select Case crType
            Case "point"
                Return LoadPoint(GR, nNode)
            Case "LineString"
                Return LoadLineString(GR, nNode)
            Case "Polygon"
                Dim I As Integer
                Dim crNode As XmlElement
                Dim crNodes As XmlNodeList
                Dim workLS As TLineString
                Dim LSList As New Microsoft.VisualBasic.Collection
                crNodes = nNode.SelectNodes(GR.LineStringPath)
                For I = 0 To crNodes.Count - 1
                    crNode = crNodes.Item(I)
                    workLS = LoadLineString(GR, crNode)
                    LSList.Add(workLS)
                Next I
                Return New TPolygon(LSList)
        End Select
    End Function

    Public Function LoadDictValue(ByRef FR As FieldRule, fValue As String) As String
        Dim workStr As String
        Dim MyDoc As New XmlDocument
        Dim crNode As XmlNode
        Dim nsmgr As XmlNamespaceManager
        workStr = "dict\" + FR.dict + ".xsd"
        MyDoc.Load(workStr)
        nsmgr = New XmlNamespaceManager(MyDoc.NameTable)
        nsmgr.AddNamespace("xs", "http://www.w3.org/2001/XMLSchema")
        workStr = "//xs:enumeration[@value=" + fValue + "]"
        crNode = MyDoc.SelectSingleNode(workStr, nsmgr)
        '
        Return crNode.FirstChild.InnerText
    End Function

End Class
