﻿' (C) Copyright 2013 by  
'
Imports System
Imports System.Xml
Imports System.Xml.XPath
'
'Imports System.Exception
Imports System.Windows.Forms
'
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.EditorInput
'
Imports Autodesk.Gis.Map.ObjectData

<Assembly: CommandClass(GetType(AcadRosReestrImp.MyCommands))> 

Namespace AcadRosReestrImp

    Public Class MyCommands
        Dim crODTable As Autodesk.Gis.Map.ObjectData.Table

        <CommandMethod("ImportXML")> _
        Public Sub ImportXML()
            'Загружаем правила и xml с данными
            Dim MyDoc, MyXMLDoc As New XmlDocument
            '
            'MyDoc.Load("D:\MyProgi\WA_RosReestr\WA_RosReestr\bin\Debug\rule.xml")
            MyDoc.Load("rule.xml")
            Dim rules As New MyStr1(MyDoc)
            'Dim myStream As Stream = Nothing
            Dim openFileDialog1 As New OpenFileDialog()

            'openFileDialog1.InitialDirectory = "c:\"
            openFileDialog1.Filter = "xml files (*.xml)|*.xml"
            'openFileDialog1.FilterIndex = 2
            'openFileDialog1.RestoreDirectory = True

            If openFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                Try
                    'myStream = openFileDialog1.OpenFile()
                    'If (myStream IsNot Nothing) Then
                    ' Insert code to read the stream here.
                    'End If
                    MyXMLDoc.Load(openFileDialog1.FileName)
                    'MyXMLDoc.Load("C:\Users\Trir\Documents\rosreestrXML\all_xml\doc369183.xml")
                    Dim ResList As New Microsoft.VisualBasic.Collection
                    ResList = rules.LoadData(MyXMLDoc)
                    Dim I, J As Integer
                    Dim WorkRecord As MyRecord
                    CreateODTable(rules)
                    For I = 1 To ResList.Count
                        WorkRecord = ResList.Item(I)
                        WriteRecord(WorkRecord)
                    Next I
                Catch Ex As System.Exception
                    MessageBox.Show("Cannot read file from disk. Original error: " & Ex.Message)
                Finally
                    ' Check this again, since we need to make sure we didn't throw an exception on open.
                    'If (myStream IsNot Nothing) Then
                    ' myStream.Close()
                    'End If
                End Try
            End If
        End Sub

        Public Sub CreateODTable(ByRef workObj As MyStr1)
            Dim mapApp As Autodesk.Gis.Map.MapApplication = Autodesk.Gis.Map.HostMapApplicationServices.Application
            Dim activeProject As Autodesk.Gis.Map.Project.ProjectModel = mapApp.ActiveProject
            Dim tableList As Autodesk.Gis.Map.ObjectData.Tables = activeProject.ODTables
            Dim fieldDefs As FieldDefinitions
            'crODTable 
            If tableList.GetTableNames.IndexOf(workObj.LayerName) = -1 Then
                'Dim def1 As ObjectData.FieldDefinition
                fieldDefs = mapApp.ActiveProject.MapUtility.NewODFieldDefinitions()
                Dim I As Integer
                Dim fNode As TitleRec
                Dim def1 As Autodesk.Gis.Map.ObjectData.FieldDefinition
                'workObj.Title.Item
                For I = 1 To workObj.Title.Count
                    fNode = workObj.Title.Item(I)
                    If Not fNode.IsGeom Then
                        def1 = fieldDefs.Add(fNode.name, _
                                             fNode.id, GetMyType(fNode.type), 0) 'Выбор на Character 
                    End If
                Next I
                tableList.Add(workObj.LayerName, fieldDefs, "Description", True)
            End If
            crODTable = tableList.Item(workObj.LayerName)
        End Sub

        Public Function GetMyType(ByVal str As String) As Autodesk.Gis.Map.Constants.DataType
            Select Case str.ToLower
                Case "string" : Return Autodesk.Gis.Map.Constants.DataType.Character
                Case "integer" : Return Autodesk.Gis.Map.Constants.DataType.Integer
                Case "double" : Return Autodesk.Gis.Map.Constants.DataType.Real
            End Select
        End Function

        Public Function DrawPoint(ByRef wP As TPoint) As ObjectId
            '' Get the current document and database
            Dim acDoc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument
            Dim acCurDb As Database = acDoc.Database
            '' Start a transaction
            Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()
                '' Open the Block table for read
                Dim acBlkTbl As BlockTable
                acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, OpenMode.ForRead)
                '' Open the Block table record Model space for write
                Dim acBlkTblRec As BlockTableRecord
                acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace), OpenMode.ForWrite)
                Dim acPoint As DBPoint = New DBPoint(New Point3d(wP.Coord.X, wP.Coord.Y, 0))
                acBlkTblRec.AppendEntity(acPoint)
                acTrans.AddNewlyCreatedDBObject(acPoint, True)
                ' Save the new object to the database
                acTrans.Commit()
                Return acPoint.ObjectId
            End Using
        End Function

        Public Function DrawPolyLine(ByRef wL As TLineString) As ObjectId
            '' Get the current document and database
            Dim acDoc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument
            Dim acCurDb As Database = acDoc.Database
            '' Start a transaction
            Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()
                '' Open the Block table for read
                Dim acBlkTbl As BlockTable
                acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, OpenMode.ForRead)
                '' Open the Block table record Model space for write
                Dim acBlkTblRec As BlockTableRecord
                acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace), OpenMode.ForWrite)
                Dim workPoint As TPoint
                Dim acPoly As Polyline = New Polyline()
                acPoly.SetDatabaseDefaults()
                Dim I As Integer
                For I = 1 To wL.Coords.Count
                    workPoint = wL.Coords.Item(I)
                    acPoly.AddVertexAt(0, New Point2d(workPoint.Coord.X, workPoint.Coord.Y), 0, 0, 0)
                Next I
                'Dim acPoint As DBPoint = New DBPoint(New Point3d(wP.X, wP.Y, 0))
                acBlkTblRec.AppendEntity(acPoly)
                acTrans.AddNewlyCreatedDBObject(acPoly, True)
                ' Save the new object to the database
                acTrans.Commit()
                Return acPoly.ObjectId
            End Using
        End Function

        Public Function DrawPolygon(ByRef wPoly As TPolygon) As ObjectId
            '' Get the current document and database
            Dim acDoc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument
            Dim acCurDb As Database = acDoc.Database
            '' Start a transaction
            Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()
                '' Open the Block table for read
                Dim acBlkTbl As BlockTable
                acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, OpenMode.ForRead)
                '' Open the Block table record Model space for write
                Dim acBlkTblRec As BlockTableRecord
                acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace), OpenMode.ForWrite)
                Dim acPolyColl As MPolygonLoopCollection
                acPolyColl = ConvertPolygon(wPoly)
                Dim MPoly As New MPolygon()
                For Each acPoly In acPolyColl
                    MPoly.AppendMPolygonLoop(acPoly, False, 0)
                Next
                MPoly.PatternScale = 50
                MPoly.PatternSpace = 50
                MPoly.SetPattern(HatchPatternType.PreDefined, "ANSI37")
                acBlkTblRec.AppendEntity(MPoly)
                acTrans.AddNewlyCreatedDBObject(MPoly, True)
                ' Save the new object to the database
                acTrans.Commit()
                Return MPoly.ObjectId
            End Using
        End Function

        Public Function ConvertPolygon(ByRef wPoly As TPolygon) As MPolygonLoopCollection
            Dim I As Integer
            Dim res As New MPolygonLoopCollection
            Dim workLS As TLineString
            '
            For I = 1 To wPoly.Rings.Count
                workLS = wPoly.Rings.Item(I)
                res.Add(ConvertLineString(workLS))
            Next I
            Return res
        End Function

        Public Function ConvertLineString(ByRef wLine As TLineString) As MPolygonLoop
            Dim I As Integer
            Dim workPoint As TPoint
            Dim mPolyLoop As New MPolygonLoop()
            '
            For I = 1 To wLine.Coords.Count
                workPoint = wLine.Coords.Item(I)
                mPolyLoop.Add(New BulgeVertex(ConvertPoint2d(workPoint), 0))
            Next I
            Return mPolyLoop
        End Function

        Public Function ConvertPoint2d(ByRef wPoint As TPoint) As Point2d
            Return New Point2d(wPoint.Coord.X, wPoint.Coord.Y)
        End Function

        Public Sub WriteRecord(WorkRecord As MyRecord)
            Dim fNode As MyField
            Dim NewObjId As ObjectId
            Select Case WorkRecord.Geom.RecType
                Case GeometryType.Point.ToString
                    NewObjId = DrawPoint(WorkRecord.Geom.RecValue)
                Case GeometryType.LineString.ToString
                    NewObjId = DrawPolyLine(WorkRecord.Geom.RecValue)
                Case GeometryType.Polygon.ToString
                    NewObjId = DrawPolygon(WorkRecord.Geom.RecValue)
            End Select
            Try
                Dim acDoc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument
                Dim acCurDb As Database = acDoc.Database
                Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()
                    Dim dbObj As DBObject = acTrans.GetObject(NewObjId, Autodesk.AutoCAD.DatabaseServices.OpenMode.ForWrite)
                    Dim odrecords As Autodesk.Gis.Map.ObjectData.Records = crODTable.GetObjectTableRecords(Convert.ToUInt32(0), _
                     dbObj, Autodesk.Gis.Map.Constants.OpenMode.OpenForRead, False)
                    Dim odRecord As Autodesk.Gis.Map.ObjectData.Record = odrecords.Item(0)
                    odRecord = Autodesk.Gis.Map.ObjectData.Record.Create()
                    crODTable.InitRecord(odRecord)
                    Dim def1 As Autodesk.Gis.Map.ObjectData.FieldDefinition
                    Dim mapVal As Autodesk.Gis.Map.Utilities.MapValue
                    Dim I As Integer
                    Dim Val As String

                    For I = 0 To crODTable.FieldDefinitions.Count - 1
                        def1 = crODTable.FieldDefinitions.Item(I)
                        fNode = WorkRecord.SearchField(def1.Description)
                        mapVal = odRecord(I)
                        Val = fNode.RecValue
                        mapVal.Assign(Val)
                    Next I
                    ' dbObj should be opened for Write, otherwise
                    crODTable.AddRecord(odRecord, dbObj)
                    odRecord.Dispose()
                    odrecords.Dispose()
                    acTrans.Commit()
                End Using
            Catch exc As Autodesk.Gis.Map.MapException
                MsgBox("Error : " + exc.Message.ToString())
            End Try
        End Sub

    End Class

End Namespace